#include <MIDI.h>
// # sharp notes written as = s ex. G# == "Gs"

MIDI_CREATE_DEFAULT_INSTANCE();

int buttonCpin = 12;    //Button 1 note C
int buttonCspin = 11;   //Button 2 note Cs
int buttonDpin = 10;    //Button 3 note D...
int buttonDspin = 9;
int buttonEpin = 8;
int buttonFpin = 7;
int buttonFspin = 6;
int buttonGpin = 5;
int buttonGspin = 4;
int buttonApin = 3;
int buttonAspin = 2;
int buttonBpin = 1;

int analogpot1 = A0;  //knob 1
int analogpot2 = A1;  //knob 2

int analogpot1Old = 0;
int analogpot2Old = 0;
int analogpot1New = 0;
int analogpot2New = 0;

#define analogpot1CC 54
#define analogpot2CC 55

void setup() {
MIDI.begin (); // MIDI START

pinMode(buttonCpin, INPUT_PULLUP);
pinMode(buttonCspin, INPUT_PULLUP);
pinMode(buttonDpin, INPUT_PULLUP);
pinMode(buttonDspin, INPUT_PULLUP);
pinMode(buttonEpin, INPUT_PULLUP);
pinMode(buttonFpin, INPUT_PULLUP);
pinMode(buttonFspin, INPUT_PULLUP);
pinMode(buttonGpin, INPUT_PULLUP);
pinMode(buttonGspin, INPUT_PULLUP);
pinMode(buttonApin, INPUT_PULLUP);
pinMode(buttonAspin, INPUT_PULLUP);
pinMode(buttonBpin, INPUT_PULLUP);

pinMode(analogpot1, INPUT);
pinMode(analogpot2, INPUT);

//Serial.begin(9600);
}

void loop() {
  // put your main code here, to run repeatedly:

static bool buttonCvalueOld = HIGH;
static bool buttonCsvalueOld = HIGH;
static bool buttonDvalueOld = HIGH;
static bool buttonDsvalueOld = HIGH;
static bool buttonEvalueOld = HIGH;
static bool buttonFvalueOld = HIGH;
static bool buttonFsvalueOld = HIGH;
static bool buttonGvalueOld = HIGH;
static bool buttonGsvalueOld = HIGH;
static bool buttonAvalueOld = HIGH;
static bool buttonAsvalueOld = HIGH;
static bool buttonBvalueOld = HIGH;

//buttons
bool buttonCvalueNew = digitalRead(buttonCpin);
bool buttonCsvalueNew = digitalRead(buttonCspin);
bool buttonDvalueNew = digitalRead(buttonDpin);
bool buttonDsvalueNew = digitalRead(buttonDspin);
bool buttonEvalueNew = digitalRead(buttonEpin);
bool buttonFvalueNew = digitalRead(buttonFpin);
bool buttonFsvalueNew = digitalRead(buttonFspin);
bool buttonGvalueNew = digitalRead(buttonGpin);
bool buttonGsvalueNew = digitalRead(buttonGspin);
bool buttonAvalueNew = digitalRead(buttonApin);
bool buttonAsvalueNew = digitalRead(buttonAspin);
bool buttonBvalueNew = digitalRead(buttonBpin);


    if (buttonCvalueNew != buttonCvalueOld){
      if (buttonCvalueNew == LOW){
        MIDI.sendNoteOn(60, 127, 1);
        //Serial.println("Note C On");
      }
      else {
        MIDI.sendNoteOff(60, 0, 1);
        //Serial.println("Note C Off");
      }
      buttonCvalueOld = buttonCvalueNew;
    }

      if (buttonCsvalueNew != buttonCsvalueOld){
        if (buttonCsvalueNew == LOW){
          MIDI.sendNoteOn(61, 127, 1);
          //Serial.println("Note C# On");
      }
      else {
        MIDI.sendNoteOff(61, 0, 1);
        //Serial.println("Note C# Off");
      }
      buttonCsvalueOld = buttonCsvalueNew;
    }

      if (buttonDvalueNew != buttonDvalueOld){
        if (buttonDvalueNew == LOW){
          MIDI.sendNoteOn(62, 127, 1);
          //Serial.println("Note D On");
      }
      else {
        MIDI.sendNoteOff(62, 0, 1);
        //Serial.println("Note D Off");
      }
      buttonDvalueOld = buttonDvalueNew;
    }
    
    if (buttonDsvalueNew != buttonDsvalueOld){
      if (buttonDsvalueNew == LOW){
        MIDI.sendNoteOn(63, 127, 1);
        //Serial.println("Note D# On");
      }
      else {
        MIDI.sendNoteOff(63, 0, 1);
        //Serial.println("Note D# Off");
      }
      buttonDsvalueOld = buttonDsvalueNew;
    }
    
      if (buttonEvalueNew != buttonEvalueOld){
        if (buttonEvalueNew == LOW){
          MIDI.sendNoteOn(64, 127, 1);
          //Serial.println("Note E On");
      }
      else {
        MIDI.sendNoteOff(64, 0, 1);
        //Serial.println("Note E Off");
      }
      buttonEvalueOld = buttonEvalueNew;
    }
    
      if (buttonFvalueNew != buttonFvalueOld){
        if (buttonFvalueNew == LOW){
          MIDI.sendNoteOn(65, 127, 1);
          //Serial.println("Note F On");
      }
      else {
        MIDI.sendNoteOff(65, 0, 1);
        //Serial.println("Note F Off");
      }
      buttonFvalueOld = buttonFvalueNew;
    }

    if (buttonFsvalueNew != buttonFsvalueOld){
      if (buttonFsvalueNew == LOW){
        MIDI.sendNoteOn(66, 127, 1);
        //Serial.println("Note F# On");
      }
      else {
        MIDI.sendNoteOff(66, 0, 1);
        //Serial.println("Note F# Off");
      }
      buttonFsvalueOld = buttonFsvalueNew;
    }
    
    if (buttonGvalueNew != buttonGvalueOld){
      if (buttonGvalueNew == LOW){
        MIDI.sendNoteOn(67, 127, 1);
        //Serial.println("Note G On");
      }
      else {
        MIDI.sendNoteOff(67, 0, 1);
        //Serial.println("Note G Off");
      }
      buttonGvalueOld = buttonGvalueNew;
    }

    if (buttonGsvalueNew != buttonGsvalueOld){
      if (buttonGsvalueNew == LOW){
        MIDI.sendNoteOn(68, 127, 1);
        //Serial.println("Note G# On");
      }
      else {
        MIDI.sendNoteOff(68, 0, 1);
        //Serial.println("Note G# Off");
      }
      buttonGsvalueOld = buttonGsvalueNew;
    }

    if (buttonAvalueNew != buttonAvalueOld){
      if (buttonAvalueNew == LOW){
        MIDI.sendNoteOn(69, 127, 1);
        //Serial.println("Note A On");
      }
      else {
        MIDI.sendNoteOff(69, 0, 1);
        //Serial.println("Note A Off");
      }
      buttonAvalueOld = buttonAvalueNew;
    }

    if (buttonAsvalueNew != buttonAsvalueOld){
      if (buttonAsvalueNew == LOW){
        MIDI.sendNoteOn(70, 127, 1);
        //Serial.println("Note A# On");
      }
      else {
        MIDI.sendNoteOff(70, 0, 1);
        //Serial.println("Note A# Off");
      }
      buttonAsvalueOld = buttonAsvalueNew;
    }

    if (buttonBvalueNew != buttonBvalueOld){
      if (buttonBvalueNew == LOW){
        MIDI.sendNoteOn(71, 127, 1);
        //Serial.println("Note B On");
      }
      else {
        MIDI.sendNoteOff(71, 0, 1);
        //Serial.println("Note B Off");
      }
      buttonBvalueOld = buttonBvalueNew;
    }


//potentiometers

int pot1 = analogRead(A0);
int pot2 = analogRead(A1);
int analogpot1New = analogRead(A0);
int analogpot2New = analogRead(A1);

    if (analogpot1New - analogpot1Old >= 35 || analogpot1Old - analogpot1New >= 35) {
      analogpot1Old = analogpot1New;
      analogpot1New = (map(analogpot1New, 1023, 0, 0, 120));
      analogpot1New = (constrain(analogpot1New, 0, 120));
      MIDI.sendControlChange(analogpot1CC, analogpot1New, 1);
//      Serial.print ("pot: ");
//      Serial.println(pot1);
//      Serial.print("potread: ");
//      Serial.println(analogpot1New); 
    }
    
    if (analogpot2New - analogpot2Old >= 35 || analogpot2Old - analogpot2New >= 35) {
      analogpot2Old = analogpot2New;
      analogpot2New = (map(analogpot2New, 1023, 0, 0, 120));
      analogpot2New = (constrain(analogpot2New, 0, 120));
      MIDI.sendControlChange(analogpot2CC, analogpot2New, 1);
//      Serial.print ("pot: ");
//      Serial.println(pot2);
//      Serial.print("potread: ");
//      Serial.println(analogpot2New); 
    }

delay(25);
}
